//          Demo 6e: ObjectSortDriver.java

//       Driver for ObjectSort.java Bubble Sort Method
//    Illustrates Use of ObjectSort.java Bubble Sort Method
//       Reads In, Sorts, and Prints Out Student Records
//            A Java Screen Based Application

//              by Charles W. Neville, 1998
//            Copyright Charles W. Neville, 1998                 

//
//  Simply redo the class containing main from Demo 4, RecordAccess.java, so it 
//  calls the object bubble sort method from ObjectSort.java.

import java.io.*;
import Student;
import ObjectBubSort;

// a class to call bubSort method from the ObjectBubSort class
class ObjectSortDriver {

   public static void main(String[] args) {

      Student[] s = new Student[100];  // array of 100 Student records
 
      Student[] t;  // Student record array of exact length equal 
                    // to number of records read in

      BufferedReader br;  // input file reader
      int i;              // number of records read

     // command line format: java RecordAccess fileName
     // check to see if have correct number of command line parameters
     if(args.length != 1) {

         System.out.println("Usage: java ObjectSortDriver fileName");
         return;  // bail out of program
     }

      // file IO stuff
      try {
         br = new BufferedReader(new FileReader(args[0]));
      }
      catch(FileNotFoundException e) {
         System.out.println("Input file not found");
         return;  // bail out of program
      }

      System.out.println("Unsorted Array:");  // document output

      // read in records from file and write them to screen
      try {
         i = 0;
         while((i < s.length) && ((s[i] = Student.readStudent(br)) != null)) {
            s[i].writeStudent();  // echo print record to standard output
            System.out.println();  // one space between records
            i++;
         }
      }
      catch (NumberFormatException e) {

          System.out.println("Invalid age or gpa");
          return;
      }
      catch (IOException e) {

          System.out.println("File record access failed");
          return;
      }

      // copy the records to array of the correct length
      t = new Student[i];  // correct length
      // do copying
      for(int j = 0; j < i; j++) {
         t[j] = s[j];
      }

      // sort the records
      ObjectBubSort.bubSort(t);

      // skip two lines
      System.out.println();
      System.out.println();

      System.out.println("Sorted Array:");  // document output

      // write sorted records to the screen, with one space between each record
      for (int j = 0; j < t.length; j++) {
          t[j].writeStudent();
          System.out.println();
      }

      return;

   } // main

   // try creating a file like this and then running the program:
   //  Sanford
   //  D
   //  White
   //  46
   //  3.666
   //  Evelyn
   //  B
   //  Nesbit
   //  22
   //  4.000
   //  Joe
   //  M
   //  Bflspk
   //  22
   //  2.718
   //  Jane
   //  M
   //  Bflspk
   //  21
   //  3.14159

} // class ObjectSortDriver